QGIS Application - Bug report #6763
Labels don't wrap around 90 degree bend
2012-11-26 08:21 PM - Nathan Woodrow

Status: Closed

Priority: Normal

Assignee: Larry Shaffer

Category: Labelling

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 15916
Description

Curved labels don't seem to like wrapping around 90 degree corners. See images for examples and an example from MapServer that is
the correct behavior.

23m label height @ 1:5103m scale

qgis_5103.png

23m label height @ 1:10000m scale

qgis_10000.png

MapServer with correct label wrapping at 1:10000

mapserver.png

Related issues:

Related to QGIS Application - Feature request # 6673: Curved labels : max ang... Open 2012-11-09
Related to QGIS Application - Bug report # 2113: curved labels: only a few ar... Open 2011-07-25
History

#1 - 2012-11-26 08:22 PM - Nathan Woodrow

- File labeltest.zip added

Added sample data and fixed images.

#2 - 2012-11-27 12:09 AM - Nathan Woodrow

- Subject changed from Label don't wrap around 90 degree bend to Labels don't wrap around 90 degree bend

#3 - 2012-11-27 06:07 AM - Martin Dobias

There's a constant (max_char_angle_delta in src/core/pal/feature.h) that limits the maximum angle difference allowed between two characters. Currently it

is not exposed to outside world (although it could be) and the allowed difference is set to 20 degrees - this is to avoid ugly labels for lines that quickly
change direction.

#4 - 2012-11-27 08:50 AM - Larry Shaffer
- Status changed from Open to Feedback
Hi Martin,

Since there is now letter and word spacing for curved labels, | think exposing that option, at layer and maybe data defined levels, is be a good idea. Are you

working on it? If not, | think | have time today to do it (home from work with a bad cold).

#5 - 2012-11-27 11:49 AM - Larry Shaffer

Hi Nathan and Martin,

| have implemented this in a feature branch at my forked repo:

https://github.com/dakcarto/Quantum-GlS/tree/labeling_max-char-angle-delta_1

Currently, it works with angles from 20-90 degrees, but that doesn't work quite right, yet. | think what it needs is the splitting of Labellnfo's

max_char_angle_delta into inside and outside angles and angle_delta in feature.cpp adjusted to allow larger angles for outside than for inside.

Reason: in Nathan's example, having a 90 degree outside bend allows the label to wrap around feature, like desired, but the same 90 degree setting (at the
layer level) will cause very poor-looking inside angle collisions between chars. In my quick visual testing, it looks like a max of 45-60 for inside and maybe
just over 90 for outside angles would work well.

I will try adding splitting the inside/outside now. Any other ideas would be appreciated.

#6 - 2012-11-27 05:32 PM - Larry Shaffer

- File zoomed-out_in-40_x_out-70.png added

- Status changed from Feedback to In Progress
- File curved-chars_averaging.png added

- File zoomed-out_ins-20_x_out-20.png added
- File zoomed-in_in-40_x_out-70.png added

- File zoomed-in_in-20_x_out-20.png added

The wrapping issue should be addressed with commit commit:ee12df2 'Add option to set inside and outside maximum for delta angle between curved

label characters' (thanks for the pointer Martin)

When using these new curved label angle adjustments coupled with reasonable amounts of letter and word spacing, it dramatically increases the number
of available candidates. See attachments for comparisons.

Settings used in comparisons
Text in map units, letter and word spacing of 10 map units, inside delta angle of 40 and outside of 70.

This doesn't mean all labels are readily legible and look nice. :*) This stems from PAL's curved label character placements currently being built without any
feature simplification (as noted in #6200) or any post character-chain averaging. | think the latter is probably fairly straightforward to do, and would make
the majority of high-delta angle labels look better. See attachment:curved-chars_averaging.png (only one candidate for clarity).

Averaging could possibly happen while the chain of characters is being built, or after. Basically, when any inside (and maybe some outside) high-delta
angle overlaps occur, the related characters are rotated away from the overlap by 1/4 of the delta angle about the center of their bases (green dots in
attachment). This would allow legibility to increase, but at the cost of slight misalignment of placement to feature. So, | think it should be optional, not
automatic, with a user-defined percentage or min delta to trigger averaging. Since the individual characters are separate labels, it is possible to store the
adjusted delta angle (and new x/y label origin point) without affecting the built character chain, allowing subsequent letters to stay 'on track' with original
placement solution.
https://github.com/dakcarto/Quantum-GIS/tree/labeling_max-char-angle-delta_1
https://github.com/qgis/Quantum-GIS/blob/master/src/core/pal/feature.cpp#L833

The averaging would be a bit more difficult to perform (or would be skipped) if there were character runs greater than 2 or 3 with overlaps. This means that

averaging should probably occur after the full character chain is built.

Any opinions on that type of character averaging, or another approach (besides feature simplification), would be greatly appreciated.

#7 - 2012-11-27 05:50 PM - Larry Shaffer
- File Selection_011.png added

Note: the above commit addresses the wrapping issue, but not the alignment of the label (i.e., have the label centered on the middle point of the line, by
default, like with MapServer). Even with one candidate the label tends toward the edge of the line (something similar has been reported in other issues).
See attachment:Selection_011.png

#8 - 2012-11-27 08:35 PM - Alister Hood

Larry Shaffer wrote:

Note: the above commit addresses the wrapping issue, but not the alignment of the label (i.e., have the label centered on the middle point of the
line, by default, like with MapServer). Even with one candidate the label tends toward the edge of the line (something similar has been reported in
other issues). See attachment:Selection_011.png

Which isn't necessarily a bad thing. In some cases it may be preferable for the label to be in the middle of the line, but in other cases it is preferable for it to
be on the straightest part of the line, or on the most horizontal of the parts of the line which are relatively straight for a length longer than the label, or
something complicated like that ;)

#9 - 2014-06-28 07:43 AM - Jiirgen Fischer
- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#10 - 2017-05-01 01:09 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#11 - 2019-03-09 04:04 PM - Giovanni Manghi
- Status changed from In Progress to Closed
- Resolution set to end of life

End of life notice: QGIS 2.18 LTR
Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/

Files

qgis_51083.png 6.62 KB 2012-11-26 Nathan Woodrow
mapserver.png 117 KB 2012-11-26 Nathan Woodrow
qgis_10000.png 3.44 KB 2012-11-26 Nathan Woodrow
labeltest.zip 126 KB 2012-11-26 Nathan Woodrow
zoomed-in_in-20_x_out-20.png 44.6 KB 2012-11-27 Larry Shaffer
zoomed-in_in-40_x_out-70.png 84.6 KB 2012-11-27 Larry Shaffer
zoomed-out_ins-20_x_out-20.png 127 KB

zoomed-out_in-40_x_out-70.png 180 KB
curved-chars_averaging.png 45 KB
Selection_011.png 15.9 KB
